/// <reference types="node" />
import { Nullable, uint8 } from "./types";
export declare function $bytesFromAsciiString(source: Nullable<string>, start?: number, end?: number): uint8[];
export declare function $bufferFromArrayBuffer(a: ArrayBuffer): Buffer;
export declare function $arrayBufferFromBuffer(source: Buffer, start?: number, end?: number): ArrayBuffer;
export declare function $uint8ArrayToBinaryString(source: Nullable<Uint8Array>): string;
export declare function $binaryStringToUint8Array(source: Nullable<string>): Uint8Array;
export declare function $decodeBase64(input: string, reference?: string): Uint8Array;
export declare function $encodeBase64(source: Uint8Array | string, reference?: string): string;
interface $bufferAspectOptions {
    prefix?: string;
    suffix?: string;
    name?: string;
    separator?: string;
    showLength?: boolean;
    transformFn?: (n: number) => string;
}
export declare function $bufferAspect(source: Uint8Array | Uint16Array | Uint32Array | Buffer, opts?: $bufferAspectOptions): string;
declare global {
    export interface Uint8Array {
        leafInspect: (this: Uint8Array) => string;
    }
    export interface Uint16Array {
        leafInspect: (this: Uint16Array) => string;
    }
    export interface Uint32Array {
        leafInspect: (this: Uint32Array) => string;
    }
    export interface ArrayBuffer {
        leafInspect: (this: any) => string;
    }
}
export {};
